//
//  WKWebViewController.swift
//  openWindowTest
//
//  Created by Mark Hunte on 12/06/2020.
//  Copyright © 2020 Mark Hunte. All rights reserved.
//

import UIKit
import WebKit


class WKWebViewController: UIViewController, WKNavigationDelegate   {
    
    
    // MARK: Declare a WKWebView
    var webView: WKWebView!
    
    
    func webView(_ webView: WKWebView, decidePolicyFor navigationAction: WKNavigationAction, decisionHandler: (WKNavigationActionPolicy) -> Void) {
 
        if navigationAction.navigationType == WKNavigationType.linkActivated {
          
            let url = navigationAction.request.url
            let shared = UIApplication.shared
 
            if shared.canOpenURL(url!) {
               // shared.openURL(url!)
                shared.open((url ?? URL(string: "\(url?.absoluteString ?? "")"))!, options: [:], completionHandler: nil)
            }

          decisionHandler(WKNavigationActionPolicy.cancel)
            return
        }

        decisionHandler(WKNavigationActionPolicy.allow)
    }
   
    override func viewDidLoad() {
        
        super.viewDidLoad()
        
        
        // MARK: Init config and controller
        let wconfiguration = WKWebViewConfiguration()
        

       
        /*MARK: Media playback
         false = Play Media playback with native device player ; true =  inline */
          wconfiguration.allowsInlineMediaPlayback = false
        
      /*  UN-COMMENT FOR HYPE AND APP POSTMESSAGE COMMUNICATION
         // MARK: WKUserContentController Init :
         // We must add the webkit scripts Posted messages we expect to get from the Hype Page to the controller
         
         let wcontroller = WKUserContentController()
         wcontroller.add(self, name: "foo")
         
         //  attach controller, config to WKWebview
         wconfiguration.userContentController = wcontroller;
 */
        
        
        /* MARK: Does not require user interaction for .ie sound auto playback  */
        
         wconfiguration.mediaTypesRequiringUserActionForPlayback = []
        
        
        /*  MARK: Configure the WKWebView */
        
        webView =  WKWebView(frame: .zero, configuration: wconfiguration)
   
        
          /*  MARK: Config Load HTML: */
        let  theFileName = ("OpenUrlsTest1" as NSString).lastPathComponent
        let htmlPath = Bundle.main.path(forResource: theFileName, ofType: "html")
        
        let folderPath = Bundle.main.bundlePath
        
        let baseUrl = URL(fileURLWithPath: folderPath, isDirectory: true)
        
        do {
            
            let htmlString = try NSString(contentsOfFile: htmlPath!, encoding: String.Encoding.utf8.rawValue)
            
            webView.loadHTMLString(htmlString as String, baseURL: baseUrl)
            
        } catch {
            
            // catch error
            
        }
        
        webView.navigationDelegate = self
        
        webView.scrollView.bounces = false
        webView.scrollView.isScrollEnabled = false
        webView.isOpaque = false
        webView.isHidden = false
        
        view = webView
        
    }
    
    
    
    
}

